diff --git a/Documentation/daxctl/daxctl-create-device.txt b/Documentation/daxctl/daxctl-create-device.txt
index 05f4dbd9d61c..ad6f177fa3b9 100644
--- a/Documentation/daxctl/daxctl-create-device.txt
+++ b/Documentation/daxctl/daxctl-create-device.txt
@@ -72,6 +72,8 @@ EFI memory map with EFI_MEMORY_SP. The resultant ranges mean that it's
 OPTIONS
 -------
 include::region-option.txt[]
+include::movable-options.txt[]
+include::reconfigure-options.txt[]
 
 -s::
 --size=::
diff --git a/Documentation/daxctl/daxctl-reconfigure-device.txt b/Documentation/daxctl/daxctl-reconfigure-device.txt
index 09691d202514..32f28a5b8e82 100644
--- a/Documentation/daxctl/daxctl-reconfigure-device.txt
+++ b/Documentation/daxctl/daxctl-reconfigure-device.txt
@@ -196,47 +196,10 @@ include::region-option.txt[]
 
 	This option is mutually exclusive with -m or --mode.
 
--m::
---mode=::
-	Specify the mode to which the dax device(s) should be reconfigured.
-	- "system-ram": hotplug the device into system memory.
-
-	- "devdax": switch to the normal "device dax" mode. This requires the
-	  kernel to support hot-unplugging 'kmem' based memory. If this is not
-	  available, a reboot is the only way to switch back to 'devdax' mode.
-
--N::
---no-online::
-	By default, memory sections provided by system-ram devices will be
-	brought online automatically and immediately with the 'online_movable'
-	policy. Use this option to disable the automatic onlining behavior.
-
--C::
---check-config::
-	Get reconfiguration parameters from the global daxctl config file.
-	This is typically used when daxctl-reconfigure-device is called from
-	a systemd-udevd device unit file. The reconfiguration proceeds only
-	if the match parameters in a 'reconfigure-device' section of the
-	config match the dax device specified on the command line. See the
-	'PERSISTENT RECONFIGURATION' section for more details.
+include::reconfigure-options.txt[]
 
 include::movable-options.txt[]
 
--f::
---force::
-	- When converting from "system-ram" mode to "devdax", it is expected
-	that all the memory sections are first made offline. By default,
-	daxctl won't touch online memory. However with this option, attempt
-	to offline the memory on the NUMA node associated with the dax device
-	before converting it back to "devdax" mode.
-
-	- Additionally, if a kernel policy to auto-online blocks is detected,
-	reconfiguration to system-ram fails. With this option, the failure can
-	be overridden to allow reconfiguration regardless of kernel policy.
-	Doing this may result in a successful reconfiguration, but it may
-	not be possible to subsequently offline the memory without a reboot.
-
-
 include::human-option.txt[]
 
 include::verbose-option.txt[]
diff --git a/Documentation/daxctl/reconfigure-options.txt b/Documentation/daxctl/reconfigure-options.txt
new file mode 100644
index 000000000000..f174729eb023
--- /dev/null
+++ b/Documentation/daxctl/reconfigure-options.txt
@@ -0,0 +1,40 @@
+// SPDX-License-Identifier: GPL-2.0
+
+
+-m::
+--mode=::
+	Specify the mode to which the dax device(s) should be reconfigured.
+	- "system-ram": hotplug the device into system memory.
+
+	- "devdax": switch to the normal "device dax" mode. This requires the
+	  kernel to support hot-unplugging 'kmem' based memory. If this is not
+	  available, a reboot is the only way to switch back to 'devdax' mode.
+
+-N::
+--no-online::
+	By default, memory sections provided by system-ram devices will be
+	brought online automatically and immediately with the 'online_movable'
+	policy. Use this option to disable the automatic onlining behavior.
+
+-C::
+--check-config::
+	Get reconfiguration parameters from the global daxctl config file.
+	This is typically used when daxctl-reconfigure-device is called from
+	a systemd-udevd device unit file. The reconfiguration proceeds only
+	if the match parameters in a 'reconfigure-device' section of the
+	config match the dax device specified on the command line. See the
+	'PERSISTENT RECONFIGURATION' section for more details.
+
+-f::
+--force::
+	- When converting from "system-ram" mode to "devdax", it is expected
+	that all the memory sections are first made offline. By default,
+	daxctl won't touch online memory. However with this option, attempt
+	to offline the memory on the NUMA node associated with the dax device
+	before converting it back to "devdax" mode.
+
+	- Additionally, if a kernel policy to auto-online blocks is detected,
+	reconfiguration to system-ram fails. With this option, the failure can
+	be overridden to allow reconfiguration regardless of kernel policy.
+	Doing this may result in a successful reconfiguration, but it may
+	not be possible to subsequently offline the memory without a reboot.